


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable SpecName "*"
    variable SpecData ""
    variable SpecLength ""
    variable DataLength ""
    variable SpecTitle ""
    variable SpecShow 0
    variable SpectrumList {}
    variable SpecDim 1
    variable SpecB 0
    variable SpecR 1024
    variable SpecArgs {}
    variable DataList {}
    variable SearchName 0

    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
    }

   proc do_create2D {} {
       variable SpecName
       variable SpecB
       variable SpecR
       variable SpecArgs
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecNew  $SpecName "$SpecB" "$SpecR" "$SpecArgs"} msg]

       if {$z == 0} {
           InsertLog "SpecNew returned: [lindex $msg 5]"
       } else {
           InsertLog "SpecNew failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_create1D {} {
       variable SpecName
       variable SpecB
       variable SpecR
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecNew  $SpecName "$SpecB" "$SpecR"} msg]

       if {$z == 0} {
           InsertLog "SpecNew returned: [lindex $msg 5]"
       } else {
           InsertLog "SpecNew failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_the_inquiry {name} {
       global errorCode errorInfo
       variable SpectrumList

       set z [catch {::namespace inscope ::urn:SpectrumService SpecNames $name} msg]

       if {$z == 0} {
#           InsertLog "SpecNames returned:"
           set SpectrumList {}
           foreach item [lindex $msg 5] {
             lappend SpectrumList $item
#            InsertLog "$item"
           }
       } else {
           InsertLog "SpecNames failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_inquire {} {
       variable SpecName
       do_the_inquiry $SpecName
   }

   proc do_inquire_all {} {
       do_the_inquiry *
   }

   proc do_details {} {
       variable SpecName
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecDetails $SpecName} msg]

       if {$z == 0} {
           InsertLog "SpecDetails returned:"
           foreach item [lindex $msg 5] {InsertLog "$item"}
       } else {
           InsertLog "SpecDetails failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_title {} {
       variable SpecName
       global errorCode errorInfo
       variable DataList

       set z [catch {::namespace inscope ::urn:SpectrumService SpecGetTitle $SpecName} msg]

       if {$z == 0} {
           InsertLog "SpecGetTitle returned:"
           set DataList [lindex $msg 5]; InsertLog "[lindex $msg 5]"
       } else {
           InsertLog "SpecGetTitle failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_read {args} {
       variable SpecName
       global errorCode errorInfo

       if {[llength $args] == 0} {set b 0; set r 0}
       if {[llength $args] == 1} {set b 0; set r [first $args]}
       if {[llength $args] >= 2} {set b [first $args]; set r [second $args]}

       set z [catch {::namespace inscope ::urn:SpectrumService SpecRead1DText $SpecName $b $r} msg]

       if {$z == 0} {
           InsertLog "SpecRead1DText returned:"
           foreach item [lindex $msg 5] {InsertLog "$item"}

       } else {
           InsertLog "SpecRead1DText failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_show {args} {
       variable SpecName
       variable SpecTitle
       variable SpecData
       variable SpecLength
       variable SpecShow
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecDetails $SpecName} msg]
       if {$z == 0} {
           set details [lindex $msg 5]
           set SpecDim [first $details]
           if {$SpecDim != 1} {InsertLog "Spectrum Dimension is $SpecDim; only 1d currently supported"; return}
           set SpecBase [second $details]
#set SpecBase 1
           set SpecRange [expr [third $details] - $SpecBase]
       } else {
           InsertLog "SpecDetails failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }

       set z [catch {::namespace inscope ::urn:SpectrumService SpecGetTitle $SpecName} msg]
       if {$z == 0} {
           set SpecTitle [lindex $msg 5]
           if {$SpecTitle == ""} {set SpecTitle $SpecName} {set SpecTitle "$SpecTitle ($SpecName)"}
       } else {
           InsertLog "SpecGetTitle failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }

       set Compression [expr max(1, $SpecRange / 1024)]
#       InsertLog "Using $Compression Compression"
       set z [catch {::namespace inscope ::urn:SpectrumService SpecCompressions $Compression $Compression} msg]
       if {$z != 0} {
           InsertLog "SpecCompressions failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }
       incr SpecBase
       incr SpecRange -1
       set z [catch {::namespace inscope ::urn:SpectrumService SpecRead1DText $SpecName $SpecBase $SpecRange} msg]
       if {$z == 0} {
#           InsertLog "SpecRead1DText returned [llength [lindex $msg 5]]"
           set SpecData ""
           set data [lindex $msg 5]
           set SpecLength [llength $data]
#           InsertLog "SpecRead1DText returned $SpecLength"
           set comp [expr $SpecRange / $Compression]
           set DataLength [expr min($comp, $SpecLength)]
           incr SpecLength -1
           set leng [expr $DataLength -1]
           for {set i 0} {$i < $leng} {incr i} {
               set item [lindex $data $i]
               append SpecData "\[[expr $i * $Compression],$item\],"
           }
           set item [lindex $data $i]
           append SpecData "\[[expr $i * $Compression],$item\]"
           set SpecShow 1
       } else {
           InsertLog "SpecRead1DText failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return
       }
       set z [catch {::namespace inscope ::urn:SpectrumService SpecCompressions 1 1} msg]
   }

   proc do_delete {} {
       variable SpecName 
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecDelete $SpecName} msg]

       if {$z == 0} {
           InsertLog "SpecDelete returned: [lindex $msg 5]"
       } else {
           InsertLog "SpecDelete failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_zero {} {
       variable SpecName
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:SpectrumService SpecZero $SpecName} msg]

       if {$z == 0} {
           InsertLog "SpecZero returned: [lindex $msg 5]"
           set RegData [second [first [lindex $msg 5]]]
       } else {
           InsertLog "SpecZero failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }


   proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS
       variable SpecName
       variable SearchName
       variable SpecDim

       set SearchName 0

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   CREATE   {
                        if {$SpecDim == 1} {do_create1D}
                        if {$SpecDim == 2} {do_create2D}
                   }
                   DELETE   {do_delete}
                   ZERO     {do_zero}

                   INQUIRE    {do_inquire}
                   INQUIREALL {do_inquire_all}

                   READ     {do_read 32}
                   SPECSHOW {do_show}

                   SPECNAMES -
                   SPECNAME {set SpecName [lindex $w 1]; set SearchName 1}

                   DETAILS  {do_details}
                   TITLE    {do_title}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
    }

}   ;# end of if {$started == 0}



